/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// カスタムアサイン入力Frame用アクションクラス
// 
//
//	変更履歴
//		2004/01/08 新規作成	T.Nishiki
//
package jp.co.ntt.lms.xms.assign;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsInnerException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsScreenAction;
import jp.co.ntt.lms.xms.framework.XmsSystemException;
import jp.co.ntt.lms.xms.framework.XmsWarningException;
import jp.co.ntt.lms.lo.LoConstant;
import jp.co.ntt.lms.xmo.Lo.LoClient;
import jp.co.ntt.lms.xms.common.util.StringUtil;

/**
 * カスタムアサイン入力Frame用アクションクラス。<br>
 * @author T.Nishiki
 */
public class CustomAssignInputAction extends XmsScreenAction {

	/**
	 * リクエスト処理初期化メソッド<BR>
	 * 各HTTPリクエストの処理を行う場合の初期化処理を実装する。
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @throws XmsException 処理中に例外が発生した場合
	 */
	protected void initProcessRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {
	}

	/**
	 * カスタムアサイン入力Frame用アクション実行メソッド<BR>
	 * @param xmsRequest リクエスト・オブジェクト。<br>
	 * @param xmsResponse レスポンス・オブジェクト。<br>
	 * @exception XmsException 処理中に例外が発生した場合
	 */
	protected void processRequest(
		XmsRequest xmsRequest,
		XmsResponse xmsResponse)
		throws XmsException {

		// 入力情報データオブジェクト
		CustomAssignInputBean bean = null;
		// HTTPリクエストオブジェクト
		HttpServletRequest request = null;
		// HTTPセッション
		HttpSession session = null;

		try {
			request = xmsRequest.getRequest();
			session = request.getSession(false);
			if (session != null) {
				bean =
					(CustomAssignInputBean) session.getAttribute(
						CustomAssignConstant.KEY_INPUT_BEAN);
			}
			//==============================================================
			// セッションから取得できない場合は新規作成。
			if (bean == null) {
				bean = new CustomAssignInputBean();
				bean.setPropertiesAsNew();
			
				// リクエストパラメータから情報を補完
				supplementBeanFromRequest(bean, xmsRequest);
			}
			//==============================================================
			// 入力項目の表示非表示を設定
			setInputUasablities(bean, xmsRequest );
			//==============================================================
			// 
			
			// レスポンスに設定
			xmsResponse.setScreenBean(bean);
		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}
	}

	/**
	 * パラメータから入力値項目を初期化する。<br>
	 * @param bean 入力項目データオブジェクト。
	 * @param xmsRequest リクエスト・オブジェクト。
	 * @throws XmsException 処理中に例外が発生した場合。
	 */
	private void supplementBeanFromRequest(
		CustomAssignInputBean bean,
		XmsRequest xmsRequest)
		throws XmsException {

		// ＨＴＴＰリクエスト。
		HttpServletRequest request = null;
		// 対象教材親ＩＤ
		String parentLoId = null;
		// 教材ＩＤ
		String loId = null;
		// グループ／人ＩＤ
		String personnelId = null;
		// グループ／人親ＩＤ
		String parentGroupId = null;
		// 新規更新区別
		String operation = null;
		int intOperation = 0;

		try {
			request = xmsRequest.getRequest();
			//==================================================================
			// パラメータの取得
			// 対象教材親ＩＤ
			parentLoId =
				request.getParameter(CustomAssignConstant.PARENT_LO_ID);
			if (StringUtil.isNullString(parentLoId) == true) {
				throw new XmsWarningException(
					CustomAssignConstant.KEY_MESSAGE_INVALID_PARAMETER);
			}
			// 教材ＩＤ
			loId = request.getParameter(CustomAssignConstant.LO_ID);
			if (StringUtil.isNullString(loId) == true) {
				throw new XmsWarningException(
					CustomAssignConstant.KEY_MESSAGE_INVALID_PARAMETER);
			}
			// グループ／人親ＩＤ
			parentGroupId =
				request.getParameter(CustomAssignConstant.PARENT_GROUP_ID);
			if (StringUtil.isNullString(parentGroupId) == true) {
				throw new XmsWarningException(
					CustomAssignConstant.KEY_MESSAGE_INVALID_PARAMETER);
			}
			// グループ／人ＩＤ
			personnelId =
				request.getParameter(CustomAssignConstant.PERSONNEL_ID);
			if (StringUtil.isNullString(personnelId) == true) {
				throw new XmsWarningException(
					CustomAssignConstant.KEY_MESSAGE_INVALID_PARAMETER);
			}
			// 新規／更新区別
			operation = request.getParameter(CustomAssignConstant.NAME_OPERATE);
			intOperation =
				StringUtil.parseInt(
					operation,
					CustomAssignConstant.OPERATION_NEW);
			//==================================================================
			// 値を設定する
			bean.setParentLoId(parentLoId);
			bean.setLoId(loId);
			bean.setParentGroupId(parentGroupId);
			bean.setPersonnelId(personnelId);
			bean.setOperation(intOperation);
		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}
	}
	
	private void setInputUasablities(
			CustomAssignInputBean bean,
			XmsRequest xmsRequest)
			throws XmsException {
		
		////////////////////////////////////////////////////////////////////////
		// 変数
		// =====================================================================
		// メール使用フラグ
		boolean usableMail = false;
		String strUasableMail = null;
		int intUasableMail = 0;
		// =====================================================================
		// ＬＯ種別取得用
		LoClient client = null;
		// LOID
		String loID = null;
		// 検索結果
		boolean selectResult = false;
		// ＬＯ種別
		String loType = null;
		try {
			// =================================================================
			// メール使用可能フラグを設定
			strUasableMail = xmsRequest.getParameter(CustomAssignConstant.NAME_USABLE_MAIL);
			intUasableMail =
				StringUtil.parseInt(
					strUasableMail,
					CustomAssignConstant.USABLE_MAIL_NG);
			usableMail = (intUasableMail == CustomAssignConstant.USABLE_MAIL_OK);
			bean.setUsableMail( usableMail );
			// =================================================================
			// ＬＯ種別取得
			client = new LoClient();
			// 検索条件ＬＯＩＤを設定
			loID = bean.getLoId();
			client.setWhereLoID(loID);
			// 検索
			selectResult = client.select();
			if ( selectResult == false ) {
				throw new XmsSystemException("FAIL to select LOTYPE");
			}
			// 検索結果取得
			if ( client.next() == false ) {
				throw new XmsSystemException("FAIL to select LOTYPE");
			}
			loType = client.getLoType();
			// ＬＯ種別によって入力項目の表示／非表示を設定
			if ( loType == null ) {
				bean.setVisibleCount( true );
				bean.setVisiblePeriod( true );
			}
			// コンテナの場合、回数を非表示
			else if (loType.equals(LoConstant.LO_TYPE_CONTAINER) == true) {
				bean.setVisibleCount( false );
				bean.setVisiblePeriod( true );
			}
			// オフラインの場合、回数を非表示
			else if (loType.equals(LoConstant.LO_TYPE_OFFLINE) == true) {
				bean.setVisibleCount( false );
				bean.setVisiblePeriod( true );
			}
			// F2F（指導者）の場合、期間、回数を非表示
			else if (loType.equals(LoConstant.LO_TYPE_FACE_TO_FACE) == true) {
				bean.setVisibleCount( false );
				bean.setVisiblePeriod( false );
			}
			// その他は期間、回数を表示
			else {
				bean.setVisibleCount( true );
				bean.setVisiblePeriod( true );
			}
		} catch (XmsException e) {
			throw e;
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}
	}
}
